<template>



    <div class="cg-product-grid-wrap font1">
        <div class="cg-dash-items-grid cg-border-top" >
        <div class="cg-empty-wrap"  v-if="isEmpty">
            <div class="cg-empty-content-wrap text-center add-btm-mdm">
                <img src="/images/no-items.svg" alt="creativegoods" class="img-ﬂuid width-30">
                <h4 class="font1 grey f18 w500 pad-top-mdm pad-btm-xsml">You don't have any favorites yet.</h4>
                <a href="/all-items" class="ﬁrst theme-bg f14 w600">Browse Products</a>
            </div>
        </div>

            <div class="row"  v-if="!isEmpty">
                <div class="col-md-6 d-flex"  v-for="favorite in products_">
                    <div class="cg-product-dp col-md-3"><img class="img-fluid" :src="favorite.product.cover_photo_path" :alt="favorite.product.name" data-no-retina></div>
                    <div class="cg-product-name col-md-9">
                        <a :href="favorite.product.product_url" class="second">{{ favorite.product.name | subStrName }}</a>
                        <p>{{ favorite.date_added }}</p>
                        <div class="cg-product-star-rating">
                            <svg class="f13 feather feather-star" v-bind:class = "(favorite.product.total_average_rating >=1)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                            <svg class="f13 feather feather-star" v-bind:class = "(favorite.product.total_average_rating >=2)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                            <svg class="f13 feather feather-star" v-bind:class = "(favorite.product.total_average_rating >=3)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                            <svg class="f13 feather feather-star" v-bind:class = "(favorite.product.total_average_rating >=4)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                            <svg class="f13 feather feather-star" v-bind:class = "(favorite.product.total_average_rating >=5)?'cg-rated':'cg-norated'" xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg>
                        </div>
                        <span v-if="favorite.product.price">${{ favorite.product.price }}</span><span v-if="!favorite.product.price">Free</span>

                        <ul class="d-flex additional-btns cg-product-star-rating">
                            <li class="cg-tiny-download">
                                <a v-if="!favorite.product.is_downloaded" :href="favorite.product.product_url+'/buy-now'" class="cg-dash-items-download-btn">Buy Now</a>
                                <a v-if="favorite.product.is_downloaded":href="user_.user_url+'/download-my-item?i=' + favorite.product.id+'&j='+fake_id" target="_blank" class="cg-dash-items-download-btn">Download</a>

                            </li>
                        </ul>
                    </div>
                </div>

            </div>
        </div>
        <ShopPagination v-if="pagination.last_page > 1" :pagination="pagination" :offset="5" @paginate="fetchMyFavorites()" ></ShopPagination>


    </div>
</template>
<style lang="scss" scoped>
    .cg-product-grid-wrap{
        min-height: 300px;
    }
</style>
<script>
    import Preloader from '../components/Preloader.vue';
    import ShopPagination from '../components/ShopPagination.vue';
    export default {
        props: ['user', 'message', 'countries'],

        data(){
            return{
                user_:JSON.parse(this.user),
                message_:this.message,
                countries_:JSON.parse(this.countries),
                products_:{},
                isEmpty:false,
                fake_id:0,
                pagination: {
                    'current_page': 1
                },
            }

        },
        components:{
            ShopPagination,
            Preloader
        },
        methods: {
            fetchMyFavorites() {
                this.preLoad();
                axios.get('/get_my_favorites?page=' + this.pagination.current_page)
                    .then(response => {
                        this.products_ = response.data.data.data;
                        this.pagination = response.data.pagination;
                        if(this.products_.length ){
                          this.isEmpty=false;
                        }else{
                            this.isEmpty=true;
                        }
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },
            preLoad: function(){
                // just open
                const close = this.$preloaders.open({
                    container: ".cg-product-grid-wrap",
                    component:Preloader,
                    // cssClass: 'test' ,
                    "overlayStyle": {
                        "backgroundColor": "#fff",
                        "opacity": .1,
                    }

                    // assetStyle: {
                    //   width: "100px",
                    //   height:"400px",
                    // },
                    // overlayStyle: {
                    //   backgroundColor: "#4bc5b3",
                    //   opacity: 1
                    // }
                });

                // and close. That's it.
                setTimeout(close, 1500);
            }
        },
        filters: {

            subStrName: function(string)
            {
                if(string.length >31)
                {
                    return string.substring(0,28) + '...';
                }
                else
                {
                    return string.substring(0,31);
                }
            },



        },
        mounted(){
            this.fake_id = Math.floor(100000 + Math.random() * 900000);
            this.fetchMyFavorites();
            this.preLoad() ;
        },
        beforeCreate() {
            this.isEmpty=false;
         },
        watch: {

            pageChange(){
                this.preLoad() ;
            }

        }
    }

</script>
